require "podsorz/version"
require "podsorz/util/process_operator"

require "podsorz/command/setup"
require "podsorz/command/switch"
require "podsorz/command/commit"
require "podsorz/command/publish"
require "podsorz/command/sync"
require "podsorz/command/binary"
require "podsorz/command/install"
require "podsorz/command/check"
require "podsorz/command/sort"

require 'gli'

include GLI::App

module PodsOrz
  program_desc %{iOS application modulize into pods, improvement for develop modules. 
    CMD:
    1.git-flow
    2.auto publish code
    3.auto push repo
    4.auto rewrite podfile
    5.sync other branch commit
    6.binary static libary
  }

  current_exec_path = Dir.pwd()

  flag %i[p path], default_value: current_exec_path
  
  if ProcessOperator.already_in_process
  	Logger.error("There is another 'podsorz' command in process, please wait")
  	exit()
  end

  setup_command()
  switch_command()
  commit_command()
  publish_command()
  install_command()
  sync_command()
  binary_command()
  check_command()
  sort_command()

  desc "Show podsorz version"
  command :version do |version|
  	version.action do |global_options, options, args|
  		p VERSION
  	end
  end

  exit run(ARGV)
end
