require "podsorz/core/PodsOrz/pods_detector"
require "podsorz/core/PodsOrz/pods_git_manager"

module PodsOrz
	def self.commit_command
		desc "Execute git commit command"
		command :commit do |commit|
			commit.switch :push, :negatable => false, :desc => "Push Local branch & commits into remote"
			commit.switch :notify, :negatable => false, :desc => "1.Merge personal branch & commit into parent(base on) branch 2.Update Podfile_orz.rb"
			commit.example "podsorz commit", desc:"Just local branch commit" 
			commit.example "podsorz commit --push", desc:"Push Local branch & commits into remote" 
			commit.example "podsorz commit --push --notify", desc:"1.Push Local branch & commits into remote 2.Update Podfile_orz.rb 3.If personal branch, merge into parent branch"
			commit.example "podsorz commit --notify ❌", desc:"Not support,illegality command"

			commit.action do |global_options, options, args|
				is_push = options[:push]
				is_notify = options[:notify]

				if is_push == false && is_notify == true
					help_now!("illegality 'notify' options")
				end

				dir_path = global_options[:path]
				detector = PodsOrz::PodsDetector.new(dir_path)
				detector.start_detector()

				git_manager = PodsOrz::PodsGitManager.new(dir_path)
				is_same = git_manager.ensure_pods_branch()
				exit() unless is_same

				git_manager.pod_commit(is_push, is_notify)
			end
		end
	end
end