require "podsorz/core/PodsOrz/pods_detector"
require "podsorz/core/PodsOrz/pods_git_manager"
require "podsorz/command/binary"

module PodsOrz
	def self.install_command
		desc "Pod Install command, do the same with 'pod install'.Repo will update to latest, pod in 'FIX_POD_LIST' NOT update to latest!"
		command :install do |install|
			install.example "podsorz install", :desc => "Install pods, 'FIX_POD_LIST' are 'NOT' updated to latest, they are using your local 'git' code"

			install.action do |global_options, options, args|
				dir_path = global_options[:path]
				detector = PodsOrz::PodsDetector.new(dir_path)
				detector.start_detector()

				git_manager = PodsOrz::PodsGitManager.new(dir_path)
				is_same = git_manager.ensure_pods_branch()
				exit() unless is_same

				#获取binary 列表
				list_hash = PodsOrz.filter_binary_pods_list(dir_path,git_manager, :binary)

				git_manager.install_pod(dir_path, list_hash[:binary])
			end
		end
	end


end