require "podsorz/core/PodsOrz/pods_detector"
require "podsorz/core/PodsOrz/pods_git_manager"
require "podsorz/util/logger"

module PodsOrz
	def self.publish_command()
		desc "Publish pods release version.Make sure everything works pass through Tester, work branch MUST be 'release'"
		long_desc %{
			what will 'podsorz publish' cmd do:\n
			1.判断 release 是否存在新的 commit 内容 \n
			2.若存在新的 commit，podspec 文件修改内容 versoin +1\n
			3.将 release 分支代码 Merge into master / develop \n
			4.为release branch 最新代码打上 New Tag\n
			5.Repo 添加kuxiu_specs 并且 更新到最新 \n
			6.比较 local version, git tag, remote version 三者关系\n
			7.发布新的组件版本\n
			8.更改远端 Podfile_orz.rb, 同步对应 pod 到最新的 version\n
		}
		command :publish do |publish|
			publish.switch :swift, :negatable => false, :desc => "Publish Swift Pod"
			publish.example "podsorz publish --swift", desc:"Single Publish Action，Publish Only One ’Swift‘ Pod" 

			publish.action do |global_options, options, args|
				dir_path = global_options[:path]
				detector = PodsOrz::PodsDetector.new(dir_path)
				detector.start_detector()

				git_manager = PodsOrz::PodsGitManager.new(dir_path)

				is_same = git_manager.ensure_pods_branch()
				exit() unless is_same

				branch_name = git_manager.fetch_pods_branch_name()
				unless branch_name.include? "release"
					Logger.error("Publish command need 'release' branch, current branch:'#{branch_name}', you should 'podsorz switch release' first")
					exit()
				end

				is_swift = options[:swift]
				git_manager.start_repo_publish(is_swift)
			end
		end
	end
end