require "podsorz/core/Config/orz_env_detector"


module PodsOrz
	def self.setup_command
		desc "Setup PodsOrz environment, init PodFile, PodsOrzConfig.rb, check Podfile_orz.rb exist"
		command :setup do |setup|
			setup.action do |global_options, options, args|
				dir_path = global_options[:path]

				is_directory = File.directory?(dir_path)

				unless is_directory
					Logger.error("Setup failure, it is not a directory path: #{dir_path}")
					exit()
				end


				detector = PodsOrz::OrzEnvDetector.new()
				detector.detect_podfile(dir_path)
				detector.detect_PodsOrzConfig(dir_path)

				podfile_orz_result = detector.detect_podfile_orz(dir_path)
			end
		end
	end

end
