require "podsorz/core/PodsOrz/pods_sort"
require "podsorz/core/Config/pod_orzconfig_parse"

module PodsOrz
	def self.sort_command
		desc "Prioritize the pods to be released and check for loops. Output the number of dependency"
		command :sort do |sort|
			sort.action do |global_options, options, args|
				dir_path = global_options[:path]

				is_directory = File.directory?(dir_path)

				unless is_directory
					Logger.error("Check failure, it is not a directory path: #{dir_path}")
					exit()
				end

                
                @orzconfig_parse = PodsOrz::PodOrzconfigParse.new(dir_path)
				kx_pods_path = File.expand_path("../#{@orzconfig_parse.file_devpods_name}", dir_path)
                pods_list = @orzconfig_parse.fix_pod_list
                if pods_list.empty?
                    Logger.warning("fix_pods is empty nothing to do")
                else
                    pods_sort = PodsOrz::PodsSort.new()
				    pods_list =  pods_sort.sort(pods_list,kx_pods_path)
                    
                end
			
			end
		end
	end

end