require "podsorz/core/PodsOrz/pods_detector"
require "podsorz/core/PodsOrz/pods_git_manager"

module PodsOrz
	def self.switch_command
		desc "Switch branch which is in fix_pods_list.Argument match 'develop', 'feature', 'release', 'bugfix'"
		arg_name '\'branch_name\''
		command :switch do |switch|
			switch.example "podsorz switch develop", desc:"siwtch into 'develop' branch."
			switch.action do |global_options, options, args|
				help_now!('branch_name is required') if args.empty?

				input_branch = args.shift.to_s.strip.chomp
				available = ["develop", "feature", "release", "bugfix"]
				result = ""
				available.each do |branch|
					cmp_result = branch.casecmp(input_branch)
					if cmp_result == 0
						result = branch
						break
					end
				end

				help_now!("branch is unknow,current support:'develop', 'feature', 'release', 'bugfix'") if result.empty?

				dir_path = global_options[:path]

				detector = PodsOrz::PodsDetector.new(dir_path)
				detector.start_detector()

				git_manager = PodsOrz::PodsGitManager.new(dir_path)
				case result
				when "develop"
					git_manager.switch_develop_state()
				when "feature"
					git_manager.switch_feature_state()
				when "release"
					git_manager.switch_release_state()
				when "bugfix"
					git_manager.switch_bugfix_state()
				end

			end
		end
	end

end