require "podsorz/util/logger"


module PodsOrz
	class PodOrzconfigParse
		attr_accessor :app_release_version, :branch_author_suffix, :fix_pod_list, :is_all_binary, :static_lib_list, :will_package_list,:remote_url_sourcecode,:remote_url_codespec,:file_devpods_name,:file_coderepo_name,:file_binaryrepo_name
		
		def initialize(main_path)
			orzconfig_path = File.expand_path("PodsOrzConfig.rb", main_path)
			orzconfig_result = File.exist?(orzconfig_path)

			unless orzconfig_result
				Logger.error("PodsOrzConfig.rb is not found. Please 'podsorz setup' first")	
				exit()
			end
			
			require orzconfig_path

			@app_release_version = GitConfig::APP_RELEASE_VERSION
			@app_release_version = "" if @app_release_version.nil?

			@branch_author_suffix = GitConfig::BRANCH_AUTHOR_SUFFIX
			@branch_author_suffix = "" if @branch_author_suffix.nil?

			@remote_url_sourcecode = GitConfig::REMOTE_URL_SOURCECODE
			@remote_url_sourcecode = "" if @remote_url_sourcecode.nil?

			@remote_url_codespec = GitConfig::REMOTE_URL_CODESPEC
			@remote_url_codespec = "" if @remote_url_codespec.nil?

			@file_devpods_name = FileConfig::FILE_DEVPODS_NAME
			@file_devpods_name = "" if @file_devpods_name.nil?

			@file_coderepo_name = FileConfig::FILE_CODEREPO_NAME
			@file_coderepo_name = "" if @file_coderepo_name.nil?

			@file_binaryrepo_name = FileConfig::FILE_BINARYREPO_NAME
			@file_binaryrepo_name = "" if @file_binaryrepo_name.nil?

			@fix_pod_list = $FIX_POD_LIST
			@fix_pod_list = [] if @fix_pod_list.nil?

			@is_all_binary = $is_all_binary
			@is_all_binary = false if @is_all_binary.nil?

			@static_lib_list = $static_lib_list
			@static_lib_list = [] if @static_lib_list.nil?

			@will_package_list = $will_package_list
			@will_package_list = [] if @will_package_list.nil?
		end
	end
end